﻿Type=Service
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Service Attributes 
#StartAtBoot: False
#End Region
Sub Process_Globals
	Dim GooglePlayServicesHelper1 As GooglePlayServicesHelper
	Dim LocationClient1 As LocationClient
	Dim LocationListener1 As LocationListener
	Dim LocationRequest1 As LocationRequest
End Sub
 
Sub Service_Create
	LocationClient1.Initialize("LocationClient1")
End Sub
 
Sub Service_Start (StartingIntent As Intent)
	If LocationClient1.IsConnected Then
Log("LocationClient IsConnected")
	Else
		Dim ServiceStatus As Int = GooglePlayServicesHelper1.IsGooglePlayServicesAvailable
		Select ServiceStatus
			Case GooglePlayServicesHelper1.SUCCESS
Log("GooglePlayServicesHelper IsGooglePlayServicesAvailable service available")
Log("LocationClient Connecting")
				LocationClient1.Connect
			Case Else
Log("GooglePlayServicesHelper IsGooglePlayServicesAvailable returned: " & ServiceStatus)
Log("Google Play Services unavailable")
				StopService("")
		End Select
	End If
End Sub
 
Sub Service_Destroy
	If LocationRequest1.IsInitialized Then
		LocationClient1.RemoveLocationUpdates(LocationListener1)
	End If
 
	If LocationClient1.IsConnected Then
		LocationClient1.Disconnect
	End If
End Sub
 
Sub LocationClient1_Connected
Log("LocationClient1_Connected")
	'the GPS library is required as we are using the Location object
	'check to see if a previous last location exists
	'	if it does then pass it to our Sub that handles the LocationListener LocationChanged event
	'	(force a location changed event before the LocationClient gets it's next GPS fix) 
	'	Dim LastLocation As Location = LocationClient1.GetLastLocation
	Main.LastLocation = LocationClient1.GetLastLocation
 
	If Main.LastLocation.IsInitialized Then
Log("LastLocation being passed to LocationListener1_LocationChanged")
Log(" ")
		LocationListener1_LocationChanged(Main.LastLocation)
	End If
	
	LocationRequest1.Initialize
	'detailed info on the LocationRequest parameters can be found:
	'	http://developer.android.com/training/location/receive-location-updates.html
	'	http://developer.android.com/reference/com/google/android/gms/location/LocationRequest.html
	LocationRequest1.SetFastestInterval(1000 * 1)		'think of this as the fastest updates that your event handling Sub can handle
	'	LocationRequest1.SetInterval(1000*6)	'this is the desired frequency of location update (units of milliseconds)
'	LocationRequest1.SetInterval(Main.GPSMinTime)	'this is the desired frequency of location update (units of milliseconds)
	LocationRequest1.SetNumUpdates(9999)				'the maximum number of updates that should be reported, after this number no more will be reported
	LocationRequest1.SetPriority(LocationRequest1.PRIORITY_HIGH_ACCURACY)	'the desired accuracy/power usage mode
	LocationListener1.Initialize("LocationListener1")
	LocationClient1.RequestLocationUpdates(LocationRequest1, LocationListener1)
End Sub
 
Sub LocationClient1_ConnectionFailed(ErrorCode As Int)
Log("LocationClient1_ConnectionFailed ErrorCode=" & ErrorCode)
	StopService("")
End Sub
 
Sub LocationClient1_Disconnected
Log("LocationClient1_Disconnected")
	StopService("")
End Sub
 
Sub LocationListener1_LocationChanged (Location1 As Location)
	Main.LastLocation = Location1
	
	'this simulates the GPS deltaTime fuctionality for getting the GPS locations which the Map dialog uses
	'	to permit LocationChanged function to be fired only every GPSMinTime ticks
'	If DateTime.now > Main.timePoint + Main.GPSMinTime Then
'		Main.timePoint = DateTime.now
'		
'		CallSub(Main, "LocationChanged")
''		If Main.bScanLoaded then CallSub(Scan, "GPS_LocationChanged")
''		If Main.bMapGLoaded Then CallSub(MapG, "LocationChanged")
'		
''		If Main.bScanLoaded Then CallSub(Scan, "LocationChanged")
''		
''		If Main.bViewScanMap = False Then CallSub(MapG, "LocationChanged")
'	End If
End Sub
 